/**
Copyright: 2024 Contrast Security, Inc
  Contact: support@contrastsecurity.com
  License: Commercial

  NOTICE: This Software and the patented inventions embodied within may only be
  used as part of Contrast Security’s commercial offerings. Even though it is
  made available through public repositories, use of this Software is subject to
  the applicable End User Licensing Agreement found at
  https://www.contrastsecurity.com/enduser-terms-0317a or as otherwise agreed
  between Contrast Security and the End User. The Software may not be reverse
  engineered, modified, repackaged, sold, redistributed or otherwise used in a
  way not consistent with the End User License Agreement.
*/
'use strict';

const ruleId = 'xxe';
const disallowedTags = ['limited-chars', 'alphanum-space-hyphen'];
const requiredTags = ['untrusted'];

const tracker = require('../../tracker');
const { Signature, CallContext } = require('../models');

module.exports = ({ common, signature }) => ({
  handle(data) {
    const [xmlString, opts] = data.args;

    // This sink is checking whether a user could potentially provide
    // XML that could load an external entity.  If noent isn't set to true
    // than libxml won't load external entities, so this isn't vulnerable
    // see: https://help.semmle.com/wiki/display/JS/XML+external+entity+expansion
    if (!opts || !opts.noent) {
      return;
    }

    const contrastProps = tracker.getData(xmlString);
    if (!contrastProps) {
      return;
    }

    const rv = common.isVulnerable({
      input: xmlString,
      requiredTags,
      disallowedTags
    });

    if (rv) {
      const ctxt = CallContext.create(data);
      common.report({
        ruleId,
        signature: new Signature(signature),
        input: xmlString,
        ctxt
      });
    }
  }
});
